/* This file contains Look Up Tables used for diagonal
 * scan for coefficient decoding
 * FIXME remove unused tables
 */
#include <stdint.h>
#include "data_scan_lut.h"


const uint8_t ff_vvc_default_num_cg[16] = {
    0, 1, 2, 3, 4, 5, 6, 7,8,9,10,11,12,13,14,15
};

const uint8_t ff_vvc_diag_scan_2x2_num_cg [4] = {
    0,  2,
    1,  3
};

const uint8_t ff_vvc_inv_diag_scan_2x2 [4] = {
    0,  2,
    1,  3,
};

const uint8_t ff_vvc_inv_diag_scan_2x2_x [4] = {
    0,  0,
    1,  1,
};

const uint8_t ff_vvc_inv_diag_scan_2x2_y [4] = {
    0,  1,
    0,  1,
};

const uint8_t ff_vvc_diag_scan_2x4_num_cg [8] = {
    0,  2,
    1,  4,
    3,  6,
    5,  7
};

const uint8_t ff_vvc_inv_diag_scan_2x4 [8] = {
    0,  2,
    1,  4,
    3,  6,
    5,  7
};

const uint8_t ff_vvc_inv_diag_scan_2x4_x [8] = {
    0,  0,
    1,  0,
    1,  0,
    1,  1
};

const uint8_t ff_vvc_inv_diag_scan_2x4_y [8] = {
    0,  1,
    0,  2,
    1,  3,
    2,  3
};

const uint8_t ff_vvc_diag_scan_2x8_num_cg [16] = {
     0,  2,
     1,  4,
     3,  6,
     5,  8,
     7, 10,
     9, 12,
    11, 14,
    13, 15
};

const uint8_t ff_vvc_inv_diag_scan_2x8 [16] = {
     0,  2,
     1,  4,
     3,  6,
     5,  8,
     7, 10,
     9, 12,
    11, 14,
    13, 15
};

const uint8_t ff_vvc_inv_diag_scan_2x8_x [16] = {
     0,  0,
     1,  0,
     1,  0,
     1,  0,
     1,  0,
     1,  0,
     1,  0,
     1,  1
};

const uint8_t ff_vvc_inv_diag_scan_2x8_y [16] = {
     0,  1,
     0,  2,
     1,  3,
     2,  4,
     3,  5,
     4,  6,
     5,  7,
     6,  7
};

const uint8_t ff_vvc_diag_scan_4x2_num_cg [8] = {
    0,  2,  4,  6,
    1,  3,  5,  7
};

const uint8_t ff_vvc_inv_diag_scan_4x2 [8] = {
    0,  4,  1,  5,
    2,  6,  3,  7
};

const uint8_t ff_vvc_inv_diag_scan_4x2_x [8] = {
    0,  0,  1,  1,
    2,  2,  3,  3
};

const uint8_t ff_vvc_inv_diag_scan_4x2_y [8] = {
    0,  1,  0,  1,
    0,  1,  0,  1
};

const uint8_t ff_vvc_diag_scan_4x4_num_cg [16] = {
    0,  2,  5,  9,
    1,  4,  8, 12,
    3,  7, 11, 14,
    6, 10, 13, 15
};

const uint8_t ff_vvc_inv_diag_scan_4x4 [16] = {
    0,  4,  1,  8,
    5,  2, 12,  9,
    6,  3, 13, 10,
    7, 14, 11, 15
};

const uint8_t ff_vvc_inv_diag_scan_4x4_x[16] = {
    0, 0, 1, 0,
    1, 2, 0, 1,
    2, 3, 1, 2,
    3, 2, 3, 3,
};

const uint8_t ff_vvc_inv_diag_scan_4x4_y[16] = {
    0, 1, 0, 2,
    1, 0, 3, 2,
    1, 0, 3, 2,
    1, 3, 2, 3,
};

const uint8_t ff_vvc_diag_scan_4x8_num_cg [32] = {
     0,  2,  5,  9,
     1,  4,  8, 13,
     3,  7, 12, 17,
     6, 11, 16, 21,
    10, 15, 20, 25,
    14, 19, 24, 28,
    18, 23, 27, 30,
    22, 26, 29, 31
};

const uint8_t ff_vvc_inv_diag_scan_4x8 [32] = {
     0,  4,  1,  8,
     5,  2, 12,  9,
     6,  3, 16, 13,
    10,  7, 20, 17,
    14, 11, 24, 21,
    18, 15, 28, 25,
    22, 19, 29, 26,
    23, 30, 27, 31
};

const uint8_t ff_vvc_inv_diag_scan_4x8_x [32] = {
     0,  0,  1,  0,
     1,  2,  0,  1,
     2,  3,  0,  1,
     2,  3,  0,  1,
     2,  3,  0,  1,
     2,  3,  0,  1,
     2,  3,  1,  2,
     3,  2,  3,  3
};

const uint8_t ff_vvc_inv_diag_scan_4x8_y [32] = {
     0,  1,  0,  2,
     1,  0,  3,  2,
     1,  0,  4,  3,
     2,  1,  5,  4,
     3,  2,  6,  5,
     4,  3,  7,  6,
     5,  4,  7,  6,
     5,  7,  6,  7
};

const uint8_t ff_vvc_diag_scan_8x2_num_cg [16] = {
    0,  2,  4,  6,  8, 10, 12, 14,
    1,  3,  5,  7,  9, 11, 13, 15
};

const uint8_t ff_vvc_inv_diag_scan_8x2 [16] = {
    0,  8,  1,  9,  2, 10,  3, 11,
    4, 12,  5, 13,  6, 14,  7, 15
};

const uint8_t ff_vvc_inv_diag_scan_8x2_x [16] = {
    0,  0,  1,  1,  2,  2,  3,  3,
    4,  4,  5,  5,  6,  6,  7,  7
};

const uint8_t ff_vvc_inv_diag_scan_8x2_y [16] = {
    0,  1,  0,  1,  0,  1,  0,  1,
    0,  1,  0,  1,  0,  1,  0,  1
};

const uint8_t ff_vvc_diag_scan_8x4_num_cg [32] = {
    0,  2,  5,  9, 13, 17, 21, 25,
    1,  4,  8, 12, 16, 20, 24, 28,
    3,  7, 11, 15, 19, 23, 27, 30,
    6, 10, 14, 18, 22, 26, 29, 31
};

const uint8_t ff_vvc_inv_diag_scan_8x4 [32] = {
     0,  8,  1, 16,  9,  2, 24, 17,
    10,  3, 25, 18, 11,  4, 26, 19,
    12,  5, 27, 20, 13,  6, 28, 21,
    14,  7, 29, 22, 15, 30, 23, 31
};

const uint8_t ff_vvc_inv_diag_scan_8x4_x [32] = {
     0,  0,  1,  0,  1,  2,  0,  1,
     2,  3,  1,  2,  3,  4,  2,  3,
     4,  5,  3,  4,  5,  6,  4,  5,
     6,  7,  5,  6,  7,  6,  7,  7
};

const uint8_t ff_vvc_inv_diag_scan_8x4_y [32] = {
     0,  1,  0,  2,  1,  0,  3,  2,
     1,  0,  3,  2,  1,  0,  3,  2,
     1,  0,  3,  2,  1,  0,  3,  2,
     1,  0,  3,  2,  1,  3,  2,  3
};

const uint8_t ff_vvc_diag_scan_8x8_num_cg [64] = {
     0,  2,  5,  9, 14, 20, 27, 35,
     1,  4,  8, 13, 19, 26, 34, 42,
     3,  7, 12, 18, 25, 33, 41, 48,
     6, 11, 17, 24, 32, 40, 47, 53,
    10, 16, 23, 31, 39, 46, 52, 57,
    15, 22, 30, 38, 45, 51, 56, 60,
    21, 29, 37, 44, 50, 55, 59, 62,
    28, 36, 43, 49, 54, 58, 61, 63
};

const uint8_t ff_vvc_inv_diag_scan_8x8 [64] = {
     0,  8,  1, 16,  9,  2, 24, 17,
    10,  3, 32, 25, 18, 11,  4, 40,
    33, 26, 19, 12,  5, 48, 41, 34,
    27, 20, 13,  6, 56, 49, 42, 35,
    28, 21, 14,  7, 57, 50, 43, 36,
    29, 22, 15, 58, 51, 44, 37, 30,
    23, 59, 52, 45, 38, 31, 60, 53,
    46, 39, 61, 54, 47, 62, 55, 63
};


const uint8_t ff_vvc_inv_diag_scan_8x8_x[64] = {
    0, 0, 1, 0, 1, 2, 0, 1,
    2, 3, 0, 1, 2, 3, 4, 0,
    1, 2, 3, 4, 5, 0, 1, 2,
    3, 4, 5, 6, 0, 1, 2, 3,
    4, 5, 6, 7, 1, 2, 3, 4,
    5, 6, 7, 2, 3, 4, 5, 6,
    7, 3, 4, 5, 6, 7, 4, 5,
    6, 7, 5, 6, 7, 6, 7, 7,
};

const uint8_t ff_vvc_inv_diag_scan_8x8_y[64] = {
    0, 1, 0, 2, 1, 0, 3, 2,
    1, 0, 4, 3, 2, 1, 0, 5,
    4, 3, 2, 1, 0, 6, 5, 4,
    3, 2, 1, 0, 7, 6, 5, 4,
    3, 2, 1, 0, 7, 6, 5, 4,
    3, 2, 1, 7, 6, 5, 4, 3,
    2, 7, 6, 5, 4, 3, 7, 6,
    5, 4, 7, 6, 5, 7, 6, 7
};

const uint8_t ff_vvc_inv_diag_scan_1x16[16] = {
   0,
   1,
   2,
   3,
   4,
   5,
   6,
   7,
   8,
   9,
  10,
  11,
  12,
  13,
  14,
  15,
};

const uint8_t ff_vvc_inv_diag_scan_16x2[32] = {
   0,   16,    1,   17,    2,   18,    3,   19,    4,   20,    5,   21,    6,   22,    7,   23,
   8,   24,    9,   25,   10,   26,   11,   27,   12,   28,   13,   29,   14,   30,   15,   31,
};

const uint8_t ff_vvc_inv_diag_scan_2x16[32] = {
   0,    2,
   1,    4,
   3,    6,
   5,    8,
   7,   10,
   9,   12,
  11,   14,
  13,   16,
  15,   18,
  17,   20,
  19,   22,
  21,   24,
  23,   26,
  25,   28,
  27,   30,
  29,   31,
};

const uint8_t ff_vvc_inv_diag_scan_16x4[64] = {
   0,   16,    1,   32,   17,    2,   48,   33,   18,    3,   49,   34,   19,    4,   50,   35,
  20,    5,   51,   36,   21,    6,   52,   37,   22,    7,   53,   38,   23,    8,   54,   39,
  24,    9,   55,   40,   25,   10,   56,   41,   26,   11,   57,   42,   27,   12,   58,   43,
  28,   13,   59,   44,   29,   14,   60,   45,   30,   15,   61,   46,   31,   62,   47,   63,
};

const uint8_t ff_vvc_inv_diag_scan_4x16[64] = {
   0,    4,    1,    8,
   5,    2,   12,    9,
   6,    3,   16,   13,
  10,    7,   20,   17,
  14,   11,   24,   21,
  18,   15,   28,   25,
  22,   19,   32,   29,
  26,   23,   36,   33,
  30,   27,   40,   37,
  34,   31,   44,   41,
  38,   35,   48,   45,
  42,   39,   52,   49,
  46,   43,   56,   53,
  50,   47,   60,   57,
  54,   51,   61,   58,
  55,   62,   59,   63,
};

const uint8_t ff_vvc_inv_diag_scan_16x8[128] = {
   0,   16,    1,   32,   17,    2,   48,   33,   18,    3,   64,   49,   34,   19,    4,   80,
  65,   50,   35,   20,    5,   96,   81,   66,   51,   36,   21,    6,  112,   97,   82,   67,
  52,   37,   22,    7,  113,   98,   83,   68,   53,   38,   23,    8,  114,   99,   84,   69,
  54,   39,   24,    9,  115,  100,   85,   70,   55,   40,   25,   10,  116,  101,   86,   71,
  56,   41,   26,   11,  117,  102,   87,   72,   57,   42,   27,   12,  118,  103,   88,   73,
  58,   43,   28,   13,  119,  104,   89,   74,   59,   44,   29,   14,  120,  105,   90,   75,
  60,   45,   30,   15,  121,  106,   91,   76,   61,   46,   31,  122,  107,   92,   77,   62,
  47,  123,  108,   93,   78,   63,  124,  109,   94,   79,  125,  110,   95,  126,  111,  127,
};

const uint8_t ff_vvc_inv_diag_scan_8x16[128] = {
   0,    8,    1,   16,    9,    2,   24,   17,
  10,    3,   32,   25,   18,   11,    4,   40,
  33,   26,   19,   12,    5,   48,   41,   34,
  27,   20,   13,    6,   56,   49,   42,   35,
  28,   21,   14,    7,   64,   57,   50,   43,
  36,   29,   22,   15,   72,   65,   58,   51,
  44,   37,   30,   23,   80,   73,   66,   59,
  52,   45,   38,   31,   88,   81,   74,   67,
  60,   53,   46,   39,   96,   89,   82,   75,
  68,   61,   54,   47,  104,   97,   90,   83,
  76,   69,   62,   55,  112,  105,   98,   91,
  84,   77,   70,   63,  120,  113,  106,   99,
  92,   85,   78,   71,  121,  114,  107,  100,
  93,   86,   79,  122,  115,  108,  101,   94,
  87,  123,  116,  109,  102,   95,  124,  117,
 110,  103,  125,  118,  111,  126,  119,  127,
};

const uint8_t ff_vvc_inv_diag_scan_16x16[256] = {
   0,   16,    1,   32,   17,    2,   48,   33,   18,    3,   64,   49,   34,   19,    4,   80,
  65,   50,   35,   20,    5,   96,   81,   66,   51,   36,   21,    6,  112,   97,   82,   67,
  52,   37,   22,    7,  128,  113,   98,   83,   68,   53,   38,   23,    8,  144,  129,  114,
  99,   84,   69,   54,   39,   24,    9,  160,  145,  130,  115,  100,   85,   70,   55,   40,
  25,   10,  176,  161,  146,  131,  116,  101,   86,   71,   56,   41,   26,   11,  192,  177,
 162,  147,  132,  117,  102,   87,   72,   57,   42,   27,   12,  208,  193,  178,  163,  148,
 133,  118,  103,   88,   73,   58,   43,   28,   13,  224,  209,  194,  179,  164,  149,  134,
 119,  104,   89,   74,   59,   44,   29,   14,  240,  225,  210,  195,  180,  165,  150,  135,
 120,  105,   90,   75,   60,   45,   30,   15,  241,  226,  211,  196,  181,  166,  151,  136,
 121,  106,   91,   76,   61,   46,   31,  242,  227,  212,  197,  182,  167,  152,  137,  122,
 107,   92,   77,   62,   47,  243,  228,  213,  198,  183,  168,  153,  138,  123,  108,   93,
  78,   63,  244,  229,  214,  199,  184,  169,  154,  139,  124,  109,   94,   79,  245,  230,
 215,  200,  185,  170,  155,  140,  125,  110,   95,  246,  231,  216,  201,  186,  171,  156,
 141,  126,  111,  247,  232,  217,  202,  187,  172,  157,  142,  127,  248,  233,  218,  203,
 188,  173,  158,  143,  249,  234,  219,  204,  189,  174,  159,  250,  235,  220,  205,  190,
 175,  251,  236,  221,  206,  191,  252,  237,  222,  207,  253,  238,  223,  254,  239,  255,
};


const uint8_t ff_vvc_inv_diag_scan_1x16_x[16] = {
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
};

const uint8_t ff_vvc_inv_diag_scan_16x2_x[32] = {
    0,    0,    1,    1,    2,    2,    3,    3,    4,    4,    5,    5,    6,    6,    7,    7,
    8,    8,    9,    9,   10,   10,   11,   11,   12,   12,   13,   13,   14,   14,   15,   15,
};

const uint8_t ff_vvc_inv_diag_scan_2x16_x[32] = {
    0,    0,
    1,    0,
    1,    0,
    1,    0,
    1,    0,
    1,    0,
    1,    0,
    1,    0,
    1,    0,
    1,    0,
    1,    0,
    1,    0,
    1,    0,
    1,    0,
    1,    0,
    1,    1,
};

const uint8_t ff_vvc_inv_diag_scan_16x4_x[64] = {
    0,    0,    1,    0,    1,    2,    0,    1,    2,    3,    1,    2,    3,    4,    2,    3,
    4,    5,    3,    4,    5,    6,    4,    5,    6,    7,    5,    6,    7,    8,    6,    7,
    8,    9,    7,    8,    9,   10,    8,    9,   10,   11,    9,   10,   11,   12,   10,   11,
   12,   13,   11,   12,   13,   14,   12,   13,   14,   15,   13,   14,   15,   14,   15,   15,
};

const uint8_t ff_vvc_inv_diag_scan_4x16_x[64] = {
    0,    0,    1,    0,
    1,    2,    0,    1,
    2,    3,    0,    1,
    2,    3,    0,    1,
    2,    3,    0,    1,
    2,    3,    0,    1,
    2,    3,    0,    1,
    2,    3,    0,    1,
    2,    3,    0,    1,
    2,    3,    0,    1,
    2,    3,    0,    1,
    2,    3,    0,    1,
    2,    3,    0,    1,
    2,    3,    0,    1,
    2,    3,    1,    2,
    3,    2,    3,    3,
};

const uint8_t ff_vvc_inv_diag_scan_16x8_x[128] = {
    0,    0,    1,    0,    1,    2,    0,    1,    2,    3,    0,    1,    2,    3,    4,    0,
    1,    2,    3,    4,    5,    0,    1,    2,    3,    4,    5,    6,    0,    1,    2,    3,
    4,    5,    6,    7,    1,    2,    3,    4,    5,    6,    7,    8,    2,    3,    4,    5,
    6,    7,    8,    9,    3,    4,    5,    6,    7,    8,    9,   10,    4,    5,    6,    7,
    8,    9,   10,   11,    5,    6,    7,    8,    9,   10,   11,   12,    6,    7,    8,    9,
   10,   11,   12,   13,    7,    8,    9,   10,   11,   12,   13,   14,    8,    9,   10,   11,
   12,   13,   14,   15,    9,   10,   11,   12,   13,   14,   15,   10,   11,   12,   13,   14,
   15,   11,   12,   13,   14,   15,   12,   13,   14,   15,   13,   14,   15,   14,   15,   15,
};

const uint8_t ff_vvc_inv_diag_scan_8x16_x[128] = {
    0,    0,    1,    0,    1,    2,    0,    1,
    2,    3,    0,    1,    2,    3,    4,    0,
    1,    2,    3,    4,    5,    0,    1,    2,
    3,    4,    5,    6,    0,    1,    2,    3,
    4,    5,    6,    7,    0,    1,    2,    3,
    4,    5,    6,    7,    0,    1,    2,    3,
    4,    5,    6,    7,    0,    1,    2,    3,
    4,    5,    6,    7,    0,    1,    2,    3,
    4,    5,    6,    7,    0,    1,    2,    3,
    4,    5,    6,    7,    0,    1,    2,    3,
    4,    5,    6,    7,    0,    1,    2,    3,
    4,    5,    6,    7,    0,    1,    2,    3,
    4,    5,    6,    7,    1,    2,    3,    4,
    5,    6,    7,    2,    3,    4,    5,    6,
    7,    3,    4,    5,    6,    7,    4,    5,
    6,    7,    5,    6,    7,    6,    7,    7,

};

const uint8_t ff_vvc_inv_diag_scan_16x16_x[256] = {
    0,    0,    1,    0,    1,    2,    0,    1,    2,    3,    0,    1,    2,    3,    4,    0,
    1,    2,    3,    4,    5,    0,    1,    2,    3,    4,    5,    6,    0,    1,    2,    3,
    4,    5,    6,    7,    0,    1,    2,    3,    4,    5,    6,    7,    8,    0,    1,    2,
    3,    4,    5,    6,    7,    8,    9,    0,    1,    2,    3,    4,    5,    6,    7,    8,
    9,   10,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,    0,    1,
    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,    0,    1,    2,    3,    4,
    5,    6,    7,    8,    9,   10,   11,   12,   13,    0,    1,    2,    3,    4,    5,    6,
    7,    8,    9,   10,   11,   12,   13,   14,    0,    1,    2,    3,    4,    5,    6,    7,
    8,    9,   10,   11,   12,   13,   14,   15,    1,    2,    3,    4,    5,    6,    7,    8,
    9,   10,   11,   12,   13,   14,   15,    2,    3,    4,    5,    6,    7,    8,    9,   10,
   11,   12,   13,   14,   15,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
   14,   15,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,    5,    6,
    7,    8,    9,   10,   11,   12,   13,   14,   15,    6,    7,    8,    9,   10,   11,   12,
   13,   14,   15,    7,    8,    9,   10,   11,   12,   13,   14,   15,    8,    9,   10,   11,
   12,   13,   14,   15,    9,   10,   11,   12,   13,   14,   15,   10,   11,   12,   13,   14,
   15,   11,   12,   13,   14,   15,   12,   13,   14,   15,   13,   14,   15,   14,   15,   15,
};


const uint8_t ff_vvc_inv_diag_scan_1x16_y[16] = {
   0,
   1,
   2,
   3,
   4,
   5,
   6,
   7,
   8,
   9,
  10,
  11,
  12,
  13,
  14,
  15,
};

const uint8_t ff_vvc_inv_diag_scan_16x2_y[32] = {
    0,    1,    0,    1,    0,    1,    0,    1,    0,    1,    0,    1,    0,    1,    0,    1,
    0,    1,    0,    1,    0,    1,    0,    1,    0,    1,    0,    1,    0,    1,    0,    1,
};

const uint8_t ff_vvc_inv_diag_scan_2x16_y[32] = {
    0,    1,
    0,    2,
    1,    3,
    2,    4,
    3,    5,
    4,    6,
    5,    7,
    6,    8,
    7,    9,
    8,   10,
    9,   11,
   10,   12,
   11,   13,
   12,   14,
   13,   15,
   14,   15,
};

const uint8_t ff_vvc_inv_diag_scan_16x4_y[64] = {
    0,    1,    0,    2,    1,    0,    3,    2,    1,    0,    3,    2,    1,    0,    3,    2,
    1,    0,    3,    2,    1,    0,    3,    2,    1,    0,    3,    2,    1,    0,    3,    2,
    1,    0,    3,    2,    1,    0,    3,    2,    1,    0,    3,    2,    1,    0,    3,    2,
    1,    0,    3,    2,    1,    0,    3,    2,    1,    0,    3,    2,    1,    3,    2,    3,
};

const uint8_t ff_vvc_inv_diag_scan_4x16_y[64] = {
    0,    1,    0,    2,
    1,    0,    3,    2,
    1,    0,    4,    3,
    2,    1,    5,    4,
    3,    2,    6,    5,
    4,    3,    7,    6,
    5,    4,    8,    7,
    6,    5,    9,    8,
    7,    6,   10,    9,
    8,    7,   11,   10,
    9,    8,   12,   11,
   10,    9,   13,   12,
   11,   10,   14,   13,
   12,   11,   15,   14,
   13,   12,   15,   14,
   13,   15,   14,   15,
};

const uint8_t ff_vvc_inv_diag_scan_16x8_y[128] = {
    0,    1,    0,    2,    1,    0,    3,    2,    1,    0,    4,    3,    2,    1,    0,    5,
    4,    3,    2,    1,    0,    6,    5,    4,    3,    2,    1,    0,    7,    6,    5,    4,
    3,    2,    1,    0,    7,    6,    5,    4,    3,    2,    1,    0,    7,    6,    5,    4,
    3,    2,    1,    0,    7,    6,    5,    4,    3,    2,    1,    0,    7,    6,    5,    4,
    3,    2,    1,    0,    7,    6,    5,    4,    3,    2,    1,    0,    7,    6,    5,    4,
    3,    2,    1,    0,    7,    6,    5,    4,    3,    2,    1,    0,    7,    6,    5,    4,
    3,    2,    1,    0,    7,    6,    5,    4,    3,    2,    1,    7,    6,    5,    4,    3,
    2,    7,    6,    5,    4,    3,    7,    6,    5,    4,    7,    6,    5,    7,    6,    7,
};

const uint8_t ff_vvc_inv_diag_scan_8x16_y[128] = {
    0,    1,    0,    2,    1,    0,    3,    2,
    1,    0,    4,    3,    2,    1,    0,    5,
    4,    3,    2,    1,    0,    6,    5,    4,
    3,    2,    1,    0,    7,    6,    5,    4,
    3,    2,    1,    0,    8,    7,    6,    5,
    4,    3,    2,    1,    9,    8,    7,    6,
    5,    4,    3,    2,   10,    9,    8,    7,
    6,    5,    4,    3,   11,   10,    9,    8,
    7,    6,    5,    4,   12,   11,   10,    9,
    8,    7,    6,    5,   13,   12,   11,   10,
    9,    8,    7,    6,   14,   13,   12,   11,
   10,    9,    8,    7,   15,   14,   13,   12,
   11,   10,    9,    8,   15,   14,   13,   12,
   11,   10,    9,   15,   14,   13,   12,   11,
   10,   15,   14,   13,   12,   11,   15,   14,
   13,   12,   15,   14,   13,   15,   14,   15,
};

const uint8_t ff_vvc_inv_diag_scan_16x16_y[256] = {
    0,    1,    0,    2,    1,    0,    3,    2,    1,    0,    4,    3,    2,    1,    0,    5,
    4,    3,    2,    1,    0,    6,    5,    4,    3,    2,    1,    0,    7,    6,    5,    4,
    3,    2,    1,    0,    8,    7,    6,    5,    4,    3,    2,    1,    0,    9,    8,    7,
    6,    5,    4,    3,    2,    1,    0,   10,    9,    8,    7,    6,    5,    4,    3,    2,
    1,    0,   11,   10,    9,    8,    7,    6,    5,    4,    3,    2,    1,    0,   12,   11,
   10,    9,    8,    7,    6,    5,    4,    3,    2,    1,    0,   13,   12,   11,   10,    9,
    8,    7,    6,    5,    4,    3,    2,    1,    0,   14,   13,   12,   11,   10,    9,    8,
    7,    6,    5,    4,    3,    2,    1,    0,   15,   14,   13,   12,   11,   10,    9,    8,
    7,    6,    5,    4,    3,    2,    1,    0,   15,   14,   13,   12,   11,   10,    9,    8,
    7,    6,    5,    4,    3,    2,    1,   15,   14,   13,   12,   11,   10,    9,    8,    7,
    6,    5,    4,    3,    2,   15,   14,   13,   12,   11,   10,    9,    8,    7,    6,    5,
    4,    3,   15,   14,   13,   12,   11,   10,    9,    8,    7,    6,    5,    4,   15,   14,
   13,   12,   11,   10,    9,    8,    7,    6,    5,   15,   14,   13,   12,   11,   10,    9,
    8,    7,    6,   15,   14,   13,   12,   11,   10,    9,    8,    7,   15,   14,   13,   12,
   11,   10,    9,    8,   15,   14,   13,   12,   11,   10,    9,   15,   14,   13,   12,   11,
   10,   15,   14,   13,   12,   11,   15,   14,   13,   12,   15,   14,   13,   15,   14,   15,
};


const uint8_t ff_vvc_diag_scan_16x1_num_cg [16] = {
   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
};

const uint8_t ff_vvc_diag_scan_16x2_num_cg [32] = {
   0,    2,    4,    6,    8,   10,   12,   14,   16,   18,   20,   22,   24,   26,   28,   30,
   1,    3,    5,    7,    9,   11,   13,   15,   17,   19,   21,   23,   25,   27,   29,   31,
};

const uint8_t ff_vvc_diag_scan_16x4_num_cg [64] = {
   0,    2,    5,    9,   13,   17,   21,   25,   29,   33,   37,   41,   45,   49,   53,   57,
   1,    4,    8,   12,   16,   20,   24,   28,   32,   36,   40,   44,   48,   52,   56,   60,
   3,    7,   11,   15,   19,   23,   27,   31,   35,   39,   43,   47,   51,   55,   59,   62,
   6,   10,   14,   18,   22,   26,   30,   34,   38,   42,   46,   50,   54,   58,   61,   63,
};

const uint8_t ff_vvc_diag_scan_16x8_num_cg [128] = {
   0,    2,    5,    9,   14,   20,   27,   35,   43,   51,   59,   67,   75,   83,   91,   99,
   1,    4,    8,   13,   19,   26,   34,   42,   50,   58,   66,   74,   82,   90,   98,  106,
   3,    7,   12,   18,   25,   33,   41,   49,   57,   65,   73,   81,   89,   97,  105,  112,
   6,   11,   17,   24,   32,   40,   48,   56,   64,   72,   80,   88,   96,  104,  111,  117,
  10,   16,   23,   31,   39,   47,   55,   63,   71,   79,   87,   95,  103,  110,  116,  121,
  15,   22,   30,   38,   46,   54,   62,   70,   78,   86,   94,  102,  109,  115,  120,  124,
  21,   29,   37,   45,   53,   61,   69,   77,   85,   93,  101,  108,  114,  119,  123,  126,
  28,   36,   44,   52,   60,   68,   76,   84,   92,  100,  107,  113,  118,  122,  125,  127,
};

const uint8_t ff_vvc_diag_scan_1x16_num_cg [16] = {
   0,
   1,
   2,
   3,
   4,
   5,
   6,
   7,
   8,
   9,
  10,
  11,
  12,
  13,
  14,
  15,
};

const uint8_t ff_vvc_diag_scan_2x16_num_cg [32] = {
   0,    2,
   1,    4,
   3,    6,
   5,    8,
   7,   10,
   9,   12,
  11,   14,
  13,   16,
  15,   18,
  17,   20,
  19,   22,
  21,   24,
  23,   26,
  25,   28,
  27,   30,
  29,   31,
};

const uint8_t ff_vvc_diag_scan_4x16_num_cg [64] = {
   0,    2,    5,    9,
   1,    4,    8,   13,
   3,    7,   12,   17,
   6,   11,   16,   21,
  10,   15,   20,   25,
  14,   19,   24,   29,
  18,   23,   28,   33,
  22,   27,   32,   37,
  26,   31,   36,   41,
  30,   35,   40,   45,
  34,   39,   44,   49,
  38,   43,   48,   53,
  42,   47,   52,   57,
  46,   51,   56,   60,
  50,   55,   59,   62,
  54,   58,   61,   63,
};

const uint8_t ff_vvc_diag_scan_8x16_num_cg [128] = {
   0,    2,    5,    9,   14,   20,   27,   35,
   1,    4,    8,   13,   19,   26,   34,   43,
   3,    7,   12,   18,   25,   33,   42,   51,
   6,   11,   17,   24,   32,   41,   50,   59,
  10,   16,   23,   31,   40,   49,   58,   67,
  15,   22,   30,   39,   48,   57,   66,   75,
  21,   29,   38,   47,   56,   65,   74,   83,
  28,   37,   46,   55,   64,   73,   82,   91,
  36,   45,   54,   63,   72,   81,   90,   99,
  44,   53,   62,   71,   80,   89,   98,  106,
  52,   61,   70,   79,   88,   97,  105,  112,
  60,   69,   78,   87,   96,  104,  111,  117,
  68,   77,   86,   95,  103,  110,  116,  121,
  76,   85,   94,  102,  109,  115,  120,  124,
  84,   93,  101,  108,  114,  119,  123,  126,
  92,  100,  107,  113,  118,  122,  125,  127,
};

const uint8_t ff_vvc_diag_scan_16x16_num_cg [256] = {
   0,    2,    5,    9,   14,   20,   27,   35,   44,   54,   65,   77,   90,  104,  119,  135,
   1,    4,    8,   13,   19,   26,   34,   43,   53,   64,   76,   89,  103,  118,  134,  150,
   3,    7,   12,   18,   25,   33,   42,   52,   63,   75,   88,  102,  117,  133,  149,  164,
   6,   11,   17,   24,   32,   41,   51,   62,   74,   87,  101,  116,  132,  148,  163,  177,
  10,   16,   23,   31,   40,   50,   61,   73,   86,  100,  115,  131,  147,  162,  176,  189,
  15,   22,   30,   39,   49,   60,   72,   85,   99,  114,  130,  146,  161,  175,  188,  200,
  21,   29,   38,   48,   59,   71,   84,   98,  113,  129,  145,  160,  174,  187,  199,  210,
  28,   37,   47,   58,   70,   83,   97,  112,  128,  144,  159,  173,  186,  198,  209,  219,
  36,   46,   57,   69,   82,   96,  111,  127,  143,  158,  172,  185,  197,  208,  218,  227,
  45,   56,   68,   81,   95,  110,  126,  142,  157,  171,  184,  196,  207,  217,  226,  234,
  55,   67,   80,   94,  109,  125,  141,  156,  170,  183,  195,  206,  216,  225,  233,  240,
  66,   79,   93,  108,  124,  140,  155,  169,  182,  194,  205,  215,  224,  232,  239,  245,
  78,   92,  107,  123,  139,  154,  168,  181,  193,  204,  214,  223,  231,  238,  244,  249,
  91,  106,  122,  138,  153,  167,  180,  192,  203,  213,  222,  230,  237,  243,  248,  252,
 105,  121,  137,  152,  166,  179,  191,  202,  212,  221,  229,  236,  242,  247,  251,  254,
 120,  136,  151,  165,  178,  190,  201,  211,  220,  228,  235,  241,  246,  250,  253,  255,
};

const uint8_t ff_vvc_per_cg_dist_significant_flag_ctx_offset_0 [16] = {
     8,  8, 8, 4,
     4,  4, 4, 4,
     4,  4, 4, 4,
     4,  0, 0, 0
};

const uint8_t ff_vvc_per_cg_dist_significant_flag_ctx_offset_1 [16] = {
    4, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0
};

const uint8_t ff_vvc_per_cg_dist_significant_flag_ctx_offset_isp_1x16 [16] = {
    8, 8, 4, 4,
     4,  0, 0, 0,
     0,  0, 0, 0,
     0,  0, 0, 0
};

const uint8_t ff_vvc_per_cg_dist_significant_flag_ctx_offset_isp_2x8 [16] = {
    8, 8,8, 4,
     4,  4, 4, 4,
     4,  0, 0, 0,
     0,  0, 0, 0
};

const uint8_t ff_vvc_per_cg_dist_parity_flag_ctx_offset_0 [16] = {
    15, 10, 10,10,
    10, 10,  5, 5,
     5,  5,  5, 5,
     5,  5,  5, 5
};

const uint8_t ff_vvc_per_cg_dist_parity_flag_ctx_offset_1 [16] = {
     5,  5,  5, 5,
     5,  5,  5, 5,
     5,  5,  5, 5,
     5,  5,  5, 0
};

const uint8_t ff_vvc_per_cg_dist_parity_flag_ctx_offset_isp_1x16 [16] = {
    15, 10, 10, 5,
     5,  5,  5, 5,
     5,  5,  0, 0,
     0,  0,  0, 0
};

const uint8_t ff_vvc_per_cg_dist_parity_flag_ctx_offset_isp_2x8_0 [16] = {
    15, 10, 10,10,
    10,  5,  5, 5,
     5,  5,  5, 5,
     5,  5,  5, 5
};

const uint8_t ff_vvc_per_cg_dist_parity_flag_ctx_offset_isp_2x8_1 [16] = {
    5, 5, 5, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0
};


const uint8_t ff_vvc_per_cg_dist_parity_flag_ctx_offset_2 [16] = {
     5,  5,  5, 0,
     0,  0,  0, 0,
     0,  0,  0, 0,
     0,  0,  0, 0
};

const uint8_t ff_vvc_no_ctx_offset [16] = {
     0,  0,  0, 0,
     0,  0,  0, 0,
     0,  0,  0, 0,
     0,  0,  0, 0
};

const uint8_t ff_vvc_parity_flag_ctx_offset_chroma [16] = {
     5,  0,  0, 0,
     0,  0,  0, 0,
     0,  0,  0, 0,
     0,  0,  0, 0
};

const uint8_t ff_vvc_significant_flag_ctx_offset_chroma [16] = {
    4, 4, 4, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0
};

const uint8_t *const ff_vvc_parity_offset[3]={
    ff_vvc_per_cg_dist_parity_flag_ctx_offset_0,
    ff_vvc_per_cg_dist_parity_flag_ctx_offset_1,
    ff_vvc_per_cg_dist_parity_flag_ctx_offset_2
};

const uint8_t *const ff_vvc_significant_offset[3] = {
    ff_vvc_per_cg_dist_significant_flag_ctx_offset_0,
    ff_vvc_per_cg_dist_significant_flag_ctx_offset_1,
    ff_vvc_no_ctx_offset
};

const uint8_t *const ff_vvc_idx_2_num[6][6] ={
    {     ff_vvc_default_num_cg,       ff_vvc_default_num_cg,
          ff_vvc_default_num_cg,       ff_vvc_default_num_cg,
          ff_vvc_default_num_cg, ff_vvc_default_num_cg },
    {     ff_vvc_default_num_cg, ff_vvc_diag_scan_2x2_num_cg,
    ff_vvc_diag_scan_2x4_num_cg, ff_vvc_diag_scan_2x8_num_cg,
    ff_vvc_diag_scan_2x8_num_cg, ff_vvc_diag_scan_2x16_num_cg },
    {     ff_vvc_default_num_cg, ff_vvc_diag_scan_4x2_num_cg,
    ff_vvc_diag_scan_4x4_num_cg, ff_vvc_diag_scan_4x8_num_cg,
    ff_vvc_diag_scan_4x8_num_cg, ff_vvc_diag_scan_4x16_num_cg },
    {     ff_vvc_default_num_cg, ff_vvc_diag_scan_8x2_num_cg,
    ff_vvc_diag_scan_8x4_num_cg, ff_vvc_diag_scan_8x8_num_cg,
    ff_vvc_diag_scan_8x8_num_cg, ff_vvc_diag_scan_8x16_num_cg },
    {     ff_vvc_default_num_cg, ff_vvc_diag_scan_16x2_num_cg,
    ff_vvc_diag_scan_16x4_num_cg, ff_vvc_diag_scan_16x8_num_cg,
    ff_vvc_diag_scan_16x8_num_cg, ff_vvc_diag_scan_16x16_num_cg }
};

const uint8_t *const ff_vvc_scan_2_idx[6][6] ={
    {     ff_vvc_default_num_cg,       ff_vvc_default_num_cg,
          ff_vvc_default_num_cg,       ff_vvc_default_num_cg,
          ff_vvc_default_num_cg, ff_vvc_default_num_cg },
    {     ff_vvc_default_num_cg,     ff_vvc_inv_diag_scan_2x2,
    ff_vvc_inv_diag_scan_2x4, ff_vvc_inv_diag_scan_2x8,
    ff_vvc_inv_diag_scan_2x8, ff_vvc_inv_diag_scan_2x8 },
    {     ff_vvc_default_num_cg,     ff_vvc_inv_diag_scan_4x2,
    ff_vvc_inv_diag_scan_4x4, ff_vvc_inv_diag_scan_4x8,
    ff_vvc_inv_diag_scan_4x8, ff_vvc_inv_diag_scan_4x8 },
    {     ff_vvc_default_num_cg,     ff_vvc_inv_diag_scan_8x2,
    ff_vvc_inv_diag_scan_8x4, ff_vvc_inv_diag_scan_8x8,
    ff_vvc_inv_diag_scan_8x8, ff_vvc_inv_diag_scan_8x8  },
    {     ff_vvc_default_num_cg,     ff_vvc_inv_diag_scan_8x2,
    ff_vvc_inv_diag_scan_8x4, ff_vvc_inv_diag_scan_8x8,
    ff_vvc_inv_diag_scan_8x8, ff_vvc_inv_diag_scan_8x8}
};

const uint8_t *const ff_vvc_scan_x[6][6] ={
    {     ff_vvc_no_ctx_offset,       ff_vvc_no_ctx_offset,
          ff_vvc_no_ctx_offset,       ff_vvc_no_ctx_offset,
          ff_vvc_no_ctx_offset, ff_vvc_no_ctx_offset },
    {     ff_vvc_default_num_cg,     ff_vvc_inv_diag_scan_2x2_x,
    ff_vvc_inv_diag_scan_2x4_x, ff_vvc_inv_diag_scan_2x8_x,
    ff_vvc_inv_diag_scan_2x16_x, ff_vvc_inv_diag_scan_2x16_x },
    {     ff_vvc_default_num_cg,     ff_vvc_inv_diag_scan_4x2_x,
    ff_vvc_inv_diag_scan_4x4_x, ff_vvc_inv_diag_scan_4x8_x,
    ff_vvc_inv_diag_scan_4x16_x, ff_vvc_inv_diag_scan_4x16_x },
    {     ff_vvc_default_num_cg,     ff_vvc_inv_diag_scan_8x2_x,
    ff_vvc_inv_diag_scan_8x4_x, ff_vvc_inv_diag_scan_8x8_x,
    ff_vvc_inv_diag_scan_8x16_x, ff_vvc_inv_diag_scan_8x16_x },
    {     ff_vvc_default_num_cg,     ff_vvc_inv_diag_scan_16x2_x,
    ff_vvc_inv_diag_scan_16x4_x, ff_vvc_inv_diag_scan_16x8_x,
    ff_vvc_inv_diag_scan_16x16_x, ff_vvc_inv_diag_scan_16x16_x }
};

const uint8_t *const ff_vvc_scan_y[6][6] ={
    {     ff_vvc_no_ctx_offset,       ff_vvc_default_num_cg,
          ff_vvc_default_num_cg,       ff_vvc_default_num_cg,
          ff_vvc_default_num_cg,       ff_vvc_default_num_cg },
    {     ff_vvc_no_ctx_offset,     ff_vvc_inv_diag_scan_2x2_y,
    ff_vvc_inv_diag_scan_2x4_y, ff_vvc_inv_diag_scan_2x8_y,
    ff_vvc_inv_diag_scan_2x16_y, ff_vvc_inv_diag_scan_2x16_y },
    {     ff_vvc_no_ctx_offset,     ff_vvc_inv_diag_scan_4x2_y,
    ff_vvc_inv_diag_scan_4x4_y, ff_vvc_inv_diag_scan_4x8_y,
    ff_vvc_inv_diag_scan_4x16_y, ff_vvc_inv_diag_scan_4x16_y },
    {     ff_vvc_no_ctx_offset,     ff_vvc_inv_diag_scan_8x2_y,
    ff_vvc_inv_diag_scan_8x4_y, ff_vvc_inv_diag_scan_8x8_y,
    ff_vvc_inv_diag_scan_8x16_y, ff_vvc_inv_diag_scan_8x16_y },
    {     ff_vvc_no_ctx_offset,     ff_vvc_inv_diag_scan_16x2_y,
    ff_vvc_inv_diag_scan_16x4_y, ff_vvc_inv_diag_scan_16x8_y,
    ff_vvc_inv_diag_scan_16x16_y, ff_vvc_inv_diag_scan_16x16_y }
};

